;The following file is a listing of the Visual LISP program for Example 6:
;This program generates layout of a cone
;
;DTR function changes degrees to radians
(defun DTR (a)
(* PI (/ A 180.0))
)
;RTD Function changes radians to degrees
(defun rtd (a)
(* a (/ 180.0 pi))
)
(defun tan (a)
(/ (sin a) (cos a))
)
(defun cone-1p ()
(graphscr)
(setvar cmdecho 0)
(setq r2 (getdist \n Enter outer radius at larger end: ))
(setq r1 (getdist \n Enter inner radius at smaller end: ))
(setq t1 (getdist \n Enter sheet thickness:-))
(setq a (getangle \n Enter cone angle:-))
;this part of the program calculates various parameters
;needed in calculating the strip layout
(setq x0 0)
(setq y0 0)
(setq sf (/ r2 3))
(setvar dimscale sf)
(setq ar a)
(setq tx (/ (* t1 (sin ar)) 2))
(setq rx2 (- r2 tx))
(setq rx1 (+ r1 tx))
(setq w (* (* 2 pi) (cos ar)))
(setq rl1 (/ rx1 (cos ar)))
(setq rl2 (/ rx2 (cos ar)))
;this part of the program calculates the x-coordinate
;of the points
(setq x1 (+ x0 rl1)
x3 (+ x0 rl2)
x2 (- x0 (* rl1 (cos (- pi w))))
x4 (- x0 (* rl2 (cos (- pi w))))
)
;this part of the program calculates the y-coordinate
;of the points
(setq y1 y0
y3 y0
y2 (+ y0 (* rl1 (sin (- pi w))))
y4 (+ y0 (* rl2 (sin (- pi w))))
)
(setq p0 (list x0 y0)
p1 (list x1 y1)
p2 (list x2 y2)
p3 (list x3 y3)
p4 (list x4 y4)
)
(command layer make ccto c 1 ccto )
(command arc p1 c p0 p2)
(command arc p3 c p0 p4)
(command line p1 p3 )
(command line p2 p4 )
(setq f1 (/ r2 24))
(setq f2 (/ r2 2))
(setq d1 (list (+ x3 f2) y3))
(setq d2 (list x0 (- y0 f2)))
(command layer make cctd c 2 cctd )
(setvar dimtih 0)
(command dim hor p0 p1 d2  baseline p3  baseline p2  baseline p4  exit)
(command dim vert p0 p2 d1  baseline p4  exit)
(setvar dimscale 1)
(setvar cmdecho 1)
(princ)
)
